diff --git a/src/main/java/net/minecraft/core/block/BlockRedstoneRepeater.java b/src/main/java/net/minecraft/core/block/RepeaterBlock.java
similarity index 52%
rename from src/main/java/net/minecraft/core/block/BlockRedstoneRepeater.java
rename to src/main/java/net/minecraft/core/block/RepeaterBlock.java
index 518b6d4e1..00d477bd3 100644
--- a/src/main/java/net/minecraft/core/block/BlockRedstoneRepeater.java
+++ b/src/main/java/net/minecraft/core/block/RepeaterBlock.java
@@ -1,36 +1,31 @@
 package net.minecraft.core.block;
 
 import net.minecraft.client.util.helper.Colors;
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
 import java.util.Random;
-
-// Referenced classes of package net.minecraft.src:
-//            Block, Material, World, IBlockAccess, 
-//            EntityLiving, MathHelper, Item, EntityPlayer
-
-public class BlockRedstoneRepeater extends Block
+public class RepeaterBlock extends Block
 {
 
-	public BlockRedstoneRepeater(String key, int id, boolean flag)
+	public RepeaterBlock(String key, String namespaceId, int id, boolean flag)
     {
-        super(key, id, Material.decoration);
+        super(key, namespaceId, id, Material.decoration);
         isRepeaterPowered = flag;
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
     }
 
     @Override
-	public boolean renderAsNormalBlock()
+	public boolean isCubeShaped()
     {
         return false;
     }
@@ -48,9 +43,9 @@ public class BlockRedstoneRepeater extends Block
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
-        return new ItemStack[] { new ItemStack(Item.repeater) };
+        return new ItemStack[] { new ItemStack(Items.REPEATER) };
     }
 
     @Override
@@ -66,98 +61,82 @@ public class BlockRedstoneRepeater extends Block
     }
 
     @Override
-	public void updateTick(World world, int x, int y, int z, Random rand)
-    {
-        int l = world.getBlockMetadata(x, y, z);
-        boolean flag = func_22022_g(world, x, y, z, l);
-        if(isRepeaterPowered && !flag)
-        {
-            world.setBlockAndMetadataWithNotify(x, y, z, Block.repeaterIdle.id, l);
-        } else
-        if(!isRepeaterPowered)
-        {
-            world.setBlockAndMetadataWithNotify(x, y, z, Block.repeaterActive.id, l);
-            if(!flag)
-            {
-                int i1 = (l & 0xc) >> 2;
-                world.scheduleBlockUpdate(x, y, z, Block.repeaterActive.id, field_22023_b[i1] * 2);
+	public void updateTick(World world, int x, int y, int z, Random rand) {
+        int meta = world.getBlockMetadata(x, y, z);
+        boolean flag = func_22022_g(world, x, y, z, meta);
+        if(isRepeaterPowered && !flag) {
+            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.REPEATER_IDLE.id, meta);
+        } else if(!isRepeaterPowered) {
+            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.REPEATER_ACTIVE.id, meta);
+            if(!flag) {
+                int i1 = (meta & 0xc) >> 2;
+                world.scheduleBlockUpdate(x, y, z, Blocks.REPEATER_ACTIVE.id, tickDelayMap[i1] * 2);
             }
         }
     }
 
     @Override
-    public boolean isIndirectlyPoweringTo(World world, int x, int y, int z, int side)
-    {
-        return isPoweringTo(world, x, y, z, side);
+    public boolean getDirectSignal(World world, int x, int y, int z, Side side) {
+        return getSignal(world, x, y, z, side);
     }
 
     @Override
-    public boolean isPoweringTo(WorldSource blockAccess, int x, int y, int z, int side)
-    {
-        if(!isRepeaterPowered)
-        {
+    public boolean getSignal(WorldSource blockAccess, int x, int y, int z, Side side) {
+        if(!isRepeaterPowered) {
             return false;
         }
-        int i1 = blockAccess.getBlockMetadata(x, y, z) & 3;
-        if(i1 == 0 && side == 3)
-        {
+        int meta = blockAccess.getBlockMetadata(x, y, z) & 3;
+        if(meta == 0 && side == Side.SOUTH) {
             return true;
         }
-        if(i1 == 1 && side == 4)
-        {
+        if(meta == 1 && side == Side.WEST) {
             return true;
         }
-        if(i1 == 2 && side == 2)
-        {
+        if(meta == 2 && side == Side.NORTH) {
             return true;
         }
-        return i1 == 3 && side == 5;
+        return meta == 3 && side == Side.EAST;
     }
 
     @Override
-	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
-    {
-        if(!canBlockStay(world, x, y, z))
-        {
+	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
+        if(!canBlockStay(world, x, y, z)) {
             dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null);
             world.setBlockWithNotify(x, y, z, 0);
             return;
         }
-        int i1 = world.getBlockMetadata(x, y, z);
-        boolean flag = func_22022_g(world, x, y, z, i1);
-        int j1 = (i1 & 0xc) >> 2;
-        if(isRepeaterPowered && !flag)
-        {
-            world.scheduleBlockUpdate(x, y, z, id, field_22023_b[j1] * 2);
-        } else
-        if(!isRepeaterPowered && flag)
-        {
-            world.scheduleBlockUpdate(x, y, z, id, field_22023_b[j1] * 2);
+        int meta = world.getBlockMetadata(x, y, z);
+        boolean flag = func_22022_g(world, x, y, z, meta);
+        int j1 = (meta & 0xc) >> 2;
+        if(isRepeaterPowered && !flag) {
+            world.scheduleBlockUpdate(x, y, z, id, tickDelayMap[j1] * 2);
+        } else if(!isRepeaterPowered && flag) {
+            world.scheduleBlockUpdate(x, y, z, id, tickDelayMap[j1] * 2);
         }
     }
 
-    private boolean func_22022_g(World world, int i, int j, int k, int l)
+    private boolean func_22022_g(World world, int x, int y, int z, int meta)
     {
-        int i1 = l & 3;
-        switch(i1)
+        int direction = meta & 3;
+        switch(direction)
         {
         case 0: // '\0'
-            return world.isBlockIndirectlyProvidingPowerTo(i, j, k + 1, 3) || world.getBlockId(i, j, k + 1) == Block.wireRedstone.id && world.getBlockMetadata(i, j, k + 1) > 0;
+            return world.isBlockIndirectlyProvidingPowerTo(x, y, z + 1, Side.SOUTH) || world.getBlockId(x, y, z + 1) == Blocks.WIRE_REDSTONE.id && world.getBlockMetadata(x, y, z + 1) > 0;
 
         case 2: // '\002'
-            return world.isBlockIndirectlyProvidingPowerTo(i, j, k - 1, 2) || world.getBlockId(i, j, k - 1) == Block.wireRedstone.id && world.getBlockMetadata(i, j, k - 1) > 0;
+            return world.isBlockIndirectlyProvidingPowerTo(x, y, z - 1, Side.NORTH) || world.getBlockId(x, y, z - 1) == Blocks.WIRE_REDSTONE.id && world.getBlockMetadata(x, y, z - 1) > 0;
 
         case 3: // '\003'
-            return world.isBlockIndirectlyProvidingPowerTo(i + 1, j, k, 5) || world.getBlockId(i + 1, j, k) == Block.wireRedstone.id && world.getBlockMetadata(i + 1, j, k) > 0;
+            return world.isBlockIndirectlyProvidingPowerTo(x + 1, y, z, Side.EAST) || world.getBlockId(x + 1, y, z) == Blocks.WIRE_REDSTONE.id && world.getBlockMetadata(x + 1, y, z) > 0;
 
         case 1: // '\001'
-            return world.isBlockIndirectlyProvidingPowerTo(i - 1, j, k, 4) || world.getBlockId(i - 1, j, k) == Block.wireRedstone.id && world.getBlockMetadata(i - 1, j, k) > 0;
+            return world.isBlockIndirectlyProvidingPowerTo(x - 1, y, z, Side.WEST) || world.getBlockId(x - 1, y, z) == Blocks.WIRE_REDSTONE.id && world.getBlockMetadata(x - 1, y, z) > 0;
         }
         return false;
     }
 
     @Override
-    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit)
     {
         int l = world.getBlockMetadata(x, y, z);
         int i1 = (l & 0xc) >> 2;
@@ -167,14 +146,8 @@ public class BlockRedstoneRepeater extends Block
     }
 
     @Override
-    public boolean canProvidePower()
-    {
-        return false;
-    }
-    
-    @Override
-    public void onBlockPlaced(World world, int x, int y, int z, Side side, EntityLiving entity, double sideHeight) {
-		int l = entity.getHorizontalPlacementDirection(side).index;
+    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+		int l = mob.getHorizontalPlacementDirection(side).index;
 		world.setBlockMetadataWithNotify(x, y, z, l);
 		boolean flag = func_22022_g(world, x, y, z, l);
 		if(flag)
@@ -184,7 +157,7 @@ public class BlockRedstoneRepeater extends Block
     }
 
     @Override
-	public void onBlockAdded(World world, int x, int y, int z)
+	public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
         world.notifyBlocksOfNeighborChange(x + 1, y, z, id);
         world.notifyBlocksOfNeighborChange(x - 1, y, z, id);
@@ -201,7 +174,7 @@ public class BlockRedstoneRepeater extends Block
     }
 
 	@Override
-	public void randomDisplayTick(World world, int x, int y, int z, Random rand) {
+	public void animationTick(World world, int x, int y, int z, Random rand) {
 		if (!isRepeaterPowered) {
 			return;
 		}
@@ -241,26 +214,26 @@ public class BlockRedstoneRepeater extends Block
 			int i1 = (meta & 0xc) >> 2;
 			switch (meta & 3) {
 			case 0:
-				zOffset = field_22024_a[i1];
+				zOffset = torchPosOffset[i1];
 				break;
 			case 2:
-				zOffset = -field_22024_a[i1];
+				zOffset = -torchPosOffset[i1];
 				break;
 			case 3:
-				xOffset = field_22024_a[i1];
+				xOffset = torchPosOffset[i1];
 				break;
 			case 1:
-				xOffset = -field_22024_a[i1];
+				xOffset = -torchPosOffset[i1];
 				break;
 			}
 		}
 		world.spawnParticle("reddust", px + xOffset, py, pz + zOffset, red, green, blue, redstoneBrightness);
 	}
 
-    public static final double field_22024_a[] = {
+    public static final double[] torchPosOffset = {
         -0.0625D, 0.0625D, 0.1875D, 0.3125D
     };
-    private static final int field_22023_b[] = {
+    private static final int[] tickDelayMap = {
         1, 2, 3, 4
     };
     public final boolean isRepeaterPowered;
diff --git a/src/main/java/net/minecraft/core/block/RetroLeavesBlock.java b/src/main/java/net/minecraft/core/block/RetroLeavesBlock.java
new file mode 100644
index 000000000..8f43daa80
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/RetroLeavesBlock.java
@@ -0,0 +1,17 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.material.Material;
+
+public class RetroLeavesBlock extends BaseLeavesBlock
+{
+	public RetroLeavesBlock(String key, String namespaceId, int id)
+	{
+        super(key, namespaceId, id, Material.leaves);
+	}
+
+    @Override
+    protected Block getSapling()
+    {
+        return Blocks.SAPLING_OAK_RETRO;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/BlockRope.java b/src/main/java/net/minecraft/core/block/RopeBlock.java
similarity index 78%
rename from src/main/java/net/minecraft/core/block/BlockRope.java
rename to src/main/java/net/minecraft/core/block/RopeBlock.java
index 3b4843561..abbefe753 100644
--- a/src/main/java/net/minecraft/core/block/BlockRope.java
+++ b/src/main/java/net/minecraft/core/block/RopeBlock.java
@@ -1,26 +1,25 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.entity.TileEntityNote;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.item.ItemToolShears;
+import net.minecraft.core.item.ToolShearsItem;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockRope
+public class RopeBlock
     extends Block {
-    public BlockRope(String key, int id) {
-        super(key, id, Material.cloth);
+    public RopeBlock(String key, String namespaceId, int id) {
+        super(key, namespaceId,id, Material.cloth);
     }
 
     @Override
-    public boolean renderAsNormalBlock() {
+    public boolean isCubeShaped() {
         return false;
     }
 
@@ -66,10 +65,10 @@ public class BlockRope
         setBlockBounds(minX, minY, minZ, maxX, maxY, maxZ);
     }
     @Override
-    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
         ItemStack heldItem = player.getHeldItem();
-        if (heldItem != null && heldItem.getItem() instanceof ItemToolShears){
+        if (heldItem != null && heldItem.getItem() instanceof ToolShearsItem){
             int meta = world.getBlockMetadata(x, y, z);
             int forceRope = (~meta) & 0b1000_0000;
             world.setBlockMetadataWithNotify(x, y, z, forceRope | (meta & 0b0111_1111));
@@ -83,7 +82,7 @@ public class BlockRope
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity) {
-        return new ItemStack[] { new ItemStack(Item.rope) };
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity) {
+        return new ItemStack[] { new ItemStack(Items.ROPE) };
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockRotatable.java b/src/main/java/net/minecraft/core/block/RotatableBlock.java
similarity index 66%
rename from src/main/java/net/minecraft/core/block/BlockRotatable.java
rename to src/main/java/net/minecraft/core/block/RotatableBlock.java
index 5b64e70bb..ce6f92075 100644
--- a/src/main/java/net/minecraft/core/block/BlockRotatable.java
+++ b/src/main/java/net/minecraft/core/block/RotatableBlock.java
@@ -1,13 +1,13 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.EntityLiving;
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-public abstract class BlockRotatable extends Block{
-    public BlockRotatable(String key, int id, Material material) {
-        super(key, id, material);
+public abstract class RotatableBlock extends Block{
+    public RotatableBlock(String key, String namespaceId, int id, Material material) {
+        super(key, namespaceId, id, material);
     }
 
     public void setDefaultDirection(World world, int i, int j, int k)
@@ -46,14 +46,14 @@ public abstract class BlockRotatable extends Block{
     }
 
     @Override
-    public void onBlockPlaced(World world, int x, int y, int z, Side side, EntityLiving entity, double sideHeight) {
-        world.setBlockMetadataWithNotify(x, y, z, entity.getPlacementDirection(side).getOpposite().getId());
+    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+        world.setBlockMetadataWithNotify(x, y, z, mob.getHorizontalPlacementDirection(side).getOpposite().getId());
     }
 
     @Override
-	public void onBlockAdded(World world, int x, int y, int z)
+	public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
-        super.onBlockAdded(world, x, y, z);
+        super.onBlockPlacedByWorld(world, x, y, z);
         setDefaultDirection(world, x, y, z);
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockTileEntityRotatable.java b/src/main/java/net/minecraft/core/block/RotatableEntityBlock.java
similarity index 63%
rename from src/main/java/net/minecraft/core/block/BlockTileEntityRotatable.java
rename to src/main/java/net/minecraft/core/block/RotatableEntityBlock.java
index 0146465bf..f8523a78e 100644
--- a/src/main/java/net/minecraft/core/block/BlockTileEntityRotatable.java
+++ b/src/main/java/net/minecraft/core/block/RotatableEntityBlock.java
@@ -1,15 +1,14 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.EntityLiving;
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.helper.Sides;
 import net.minecraft.core.world.World;
 
-public abstract class BlockTileEntityRotatable extends BlockTileEntity {
+public abstract class RotatableEntityBlock extends EntityBlock {
 
-	public BlockTileEntityRotatable(String key, int id, Material material) {
-        super(key, id, material);
+	public RotatableEntityBlock(String key, String namespaceId, int id, Material material) {
+        super(key, namespaceId, id, material);
     }
 	public void setDefaultDirection(World world, int i, int j, int k)
     {
@@ -42,14 +41,14 @@ public abstract class BlockTileEntityRotatable extends BlockTileEntity {
     }
 
     @Override
-    public void onBlockPlaced(World world, int x, int y, int z, Side side, EntityLiving entity, double sideHeight) {
-    	world.setBlockMetadataWithNotify(x, y, z, entity.getHorizontalPlacementDirection(side).getOpposite().getId());
+    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+    	world.setBlockMetadataWithNotify(x, y, z, mob.getHorizontalPlacementDirection(side).getOpposite().getId());
     }
 
     @Override
-	public void onBlockAdded(World world, int x, int y, int z)
+	public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
-        super.onBlockAdded(world, x, y, z);
+        super.onBlockPlacedByWorld(world, x, y, z);
         setDefaultDirection(world, x, y, z);
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/SandBlock.java b/src/main/java/net/minecraft/core/block/SandBlock.java
new file mode 100644
index 000000000..6c8b46b55
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/SandBlock.java
@@ -0,0 +1,87 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.entity.FallingBlockEntity;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.world.World;
+
+import java.util.Random;
+
+// Referenced classes of package net.minecraft.src:
+//            Block, Material, World, FallingBlockEntity,
+//            FireBlock
+
+public class SandBlock extends Block
+{
+
+    public SandBlock(String key, String namespaceId, int id)
+    {
+        super(key, namespaceId, id, Material.sand);
+    }
+
+    @Override
+	public void onBlockPlacedByWorld(World world, int x, int y, int z)
+    {
+        world.scheduleBlockUpdate(x, y, z, id, tickDelay());
+    }
+
+    @Override
+	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
+    {
+        world.scheduleBlockUpdate(x, y, z, id, tickDelay());
+    }
+
+    @Override
+	public void updateTick(World world, int x, int y, int z, Random rand)
+    {
+        tryToFall(world, x, y, z);
+    }
+
+    private void tryToFall(World world, int x, int y, int z)
+    {
+        if(canFallBelow(world, x, y - 1, z) && y >= 0)
+        {
+            byte byte0 = 32;
+            if(fallInstantly || !world.areBlocksLoaded(x - byte0, y - byte0, z - byte0, x + byte0, y + byte0, z + byte0))
+            {
+                world.setBlockWithNotify(x, y, z, 0);
+                for(; canFallBelow(world, x, y - 1, z) && y > 0; y--) { }
+                if(y > 0)
+                {
+                    world.setBlockWithNotify(x, y, z, id);
+                }
+            } else
+            {
+                FallingBlockEntity fallingBlockEntity = new FallingBlockEntity(world, (float)x + 0.5F, (float)y + 0.5F, (float)z + 0.5F, id);
+                world.entityJoinedWorld(fallingBlockEntity);
+            }
+        }
+    }
+
+    @Override
+    public int tickDelay()
+    {
+        return 3;
+    }
+
+    public static boolean canFallBelow(World world, int x, int y, int z)
+    {
+        int blockId = world.getBlockId(x, y, z);
+        if(blockId == 0)
+        {
+            return true;
+        }
+        if(blockId == Blocks.FIRE.id)
+        {
+            return true;
+        }
+        if(Block.hasTag(blockId, BlockTags.IS_WATER))
+        {
+            return true;
+        }
+        return Block.hasTag(blockId, BlockTags.IS_LAVA);
+    }
+
+    public static boolean fallInstantly = false;
+
+}
diff --git a/src/main/java/net/minecraft/core/block/BlockSaplingBase.java b/src/main/java/net/minecraft/core/block/SaplingBaseBlock.java
similarity index 72%
rename from src/main/java/net/minecraft/core/block/BlockSaplingBase.java
rename to src/main/java/net/minecraft/core/block/SaplingBaseBlock.java
index dac851101..a2af4d4e2 100644
--- a/src/main/java/net/minecraft/core/block/BlockSaplingBase.java
+++ b/src/main/java/net/minecraft/core/block/SaplingBaseBlock.java
@@ -2,7 +2,7 @@ package net.minecraft.core.block;
 
 import java.util.Random;
 
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.IBonemealable;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
@@ -10,16 +10,16 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
 // Referenced classes of package net.minecraft.src:
-//            BlockFlower, World, WorldGenTaiga2, WorldGenForest, 
+//            FlowerBlock, World, WorldGenTaiga2, WorldGenForest,
 //            WorldGenTrees, WorldGenBigTree, WorldGenerator
 
-public abstract class BlockSaplingBase extends BlockFlower implements IBonemealable
+public abstract class SaplingBaseBlock extends FlowerBlock implements IBonemealable
 {
 	public boolean canGrowOnSand = false;
 
-	public BlockSaplingBase(String key, int id)
+	public SaplingBaseBlock(String key, String namespaceId, int id)
     {
-        super(key, id);
+        super(key, namespaceId, id);
         float f = 0.4F;
         setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, f * 2.0F, 0.5F + f);
     }
@@ -27,7 +27,7 @@ public abstract class BlockSaplingBase extends BlockFlower implements IBonemeala
 	@Override
 	public boolean canThisPlantGrowOnThisBlockID(int i)
     {
-        return i == Block.sand.id || super.canThisPlantGrowOnThisBlockID(i);
+        return i == Blocks.SAND.id || super.canThisPlantGrowOnThisBlockID(i);
     }
 
     @Override
@@ -39,8 +39,8 @@ public abstract class BlockSaplingBase extends BlockFlower implements IBonemeala
         }
 
         if(!canGrowOnSand) {
-            if(world.getBlockId(x, y -1, z) == Block.sand.id) {
-                world.setBlockWithNotify(x, y, z, Block.deadbush.id);
+            if(world.getBlockId(x, y -1, z) == Blocks.SAND.id) {
+                world.setBlockWithNotify(x, y, z, Blocks.DEADBUSH.id);
             }	
         }
 
@@ -63,10 +63,10 @@ public abstract class BlockSaplingBase extends BlockFlower implements IBonemeala
     }
     
     @Override
-    public boolean onBonemealUsed(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced){
+    public boolean onBonemealUsed(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced){
         if(!world.isClientSide)
         {
-            ((BlockSaplingBase)Block.blocksList[id]).growTree(world, blockX, blockY, blockZ, world.rand);
+            ((SaplingBaseBlock)Block.blocksList[id]).growTree(world, blockX, blockY, blockZ, world.rand);
             if (entityplayer.getGamemode().consumeBlocks())
             {
                 itemstack.stackSize--;
diff --git a/src/main/java/net/minecraft/core/block/BlockSaplingBirch.java b/src/main/java/net/minecraft/core/block/SaplingBirchBlock.java
similarity index 54%
rename from src/main/java/net/minecraft/core/block/BlockSaplingBirch.java
rename to src/main/java/net/minecraft/core/block/SaplingBirchBlock.java
index b76481bed..8818e28b7 100644
--- a/src/main/java/net/minecraft/core/block/BlockSaplingBirch.java
+++ b/src/main/java/net/minecraft/core/block/SaplingBirchBlock.java
@@ -3,21 +3,19 @@ package net.minecraft.core.block;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
 import net.minecraft.core.world.generate.feature.WorldFeature;
-import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeCherry;
-import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancy;
 
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
-//            BlockFlower, World, WorldGenTaiga2, WorldGenForest, 
+//            FlowerBlock, World, WorldGenTaiga2, WorldGenForest,
 //            WorldGenTrees, WorldGenBigTree, WorldGenerator
 
-public class BlockSaplingBirch extends BlockSaplingBase
+public class SaplingBirchBlock extends SaplingBaseBlock
 {
 
-	public BlockSaplingBirch(String key, int id)
+	public SaplingBirchBlock(String key, String namespaceId, int id)
     {
-        super(key, id);
+        super(key, namespaceId, id);
     }
 
 
@@ -28,9 +26,9 @@ public class BlockSaplingBirch extends BlockSaplingBase
 
     	world.setBlock(i, j, k, 0);
 
-    	obj = new WorldFeatureTree(Block.leavesBirch.id, Block.logBirch.id, 5);
+    	obj = new WorldFeatureTree(Blocks.LEAVES_BIRCH.id, Blocks.LOG_BIRCH.id, 5);
 
-        if(!((WorldFeature) (obj)).generate(world, random, i, j, k))
+        if(!((WorldFeature) (obj)).place(world, random, i, j, k))
         {
             world.setBlock(i, j, k, id);
         }
diff --git a/src/main/java/net/minecraft/core/block/BlockSaplingCacao.java b/src/main/java/net/minecraft/core/block/SaplingCacaoBlock.java
similarity index 57%
rename from src/main/java/net/minecraft/core/block/BlockSaplingCacao.java
rename to src/main/java/net/minecraft/core/block/SaplingCacaoBlock.java
index d07e47e78..1db56e5d2 100644
--- a/src/main/java/net/minecraft/core/block/BlockSaplingCacao.java
+++ b/src/main/java/net/minecraft/core/block/SaplingCacaoBlock.java
@@ -6,21 +6,21 @@ import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
 
 import java.util.Random;
 
-public class BlockSaplingCacao extends BlockSaplingBase
+public class SaplingCacaoBlock extends SaplingBaseBlock
 {
 
-    public BlockSaplingCacao(String key, int id)
+    public SaplingCacaoBlock(String key, String namespaceId, int id)
     {
-        super(key, id);
+        super(key, namespaceId, id);
     }
 
     @Override
     public void growTree(World world, int i, int j, int k, Random random)
     {
-        Object treeSmall = new WorldFeatureTree(Block.leavesCacao.id, Block.logOakMossy.id, 4);
+        Object treeSmall = new WorldFeatureTree(Blocks.LEAVES_CACAO.id, Blocks.LOG_OAK_MOSSY.id, 4);
         world.setBlock(i, j, k, 0);
 
-        if(!((WorldFeature) (treeSmall)).generate(world, random, i, j, k))
+        if(!((WorldFeature) (treeSmall)).place(world, random, i, j, k))
         {
                 world.setBlock(i, j, k, id);
         }
diff --git a/src/main/java/net/minecraft/core/block/BlockSaplingCherry.java b/src/main/java/net/minecraft/core/block/SaplingCherryBlock.java
similarity index 53%
rename from src/main/java/net/minecraft/core/block/BlockSaplingCherry.java
rename to src/main/java/net/minecraft/core/block/SaplingCherryBlock.java
index 65023a6c0..9a8e99d6b 100644
--- a/src/main/java/net/minecraft/core/block/BlockSaplingCherry.java
+++ b/src/main/java/net/minecraft/core/block/SaplingCherryBlock.java
@@ -8,27 +8,27 @@ import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeCherry;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancy;
 
 // Referenced classes of package net.minecraft.src:
-//            BlockFlower, World, WorldGenTaiga2, WorldGenForest, 
+//            FlowerBlock, World, WorldGenTaiga2, WorldGenForest,
 //            WorldGenTrees, WorldGenBigTree, WorldGenerator
 
-public class BlockSaplingCherry extends BlockSaplingBase
+public class SaplingCherryBlock extends SaplingBaseBlock
 {
 
-	public BlockSaplingCherry(String key, int id)
+	public SaplingCherryBlock(String key, String namespaceId, int id)
     {
-        super(key, id);
+        super(key, namespaceId, id);
     }
 
     @Override
 	public void growTree(World world, int i, int j, int k, Random random)
     {
-        Object treeBig  = new WorldFeatureTreeFancy(Block.leavesCherry.id, Block.logCherry.id);
-        Object treeSmall = new WorldFeatureTreeCherry(Block.leavesCherry.id, Block.logCherry.id, 4);
+        Object treeBig  = new WorldFeatureTreeFancy(Blocks.LEAVES_CHERRY.id, Blocks.LOG_CHERRY.id);
+        Object treeSmall = new WorldFeatureTreeCherry(Blocks.LEAVES_CHERRY.id, Blocks.LOG_CHERRY.id, 4);
         world.setBlock(i, j, k, 0);
 
-        if(!((WorldFeature) (treeSmall)).generate(world, random, i, j, k))
+        if(!((WorldFeature) (treeSmall)).place(world, random, i, j, k))
         {
-            if(!((WorldFeature) (treeBig)).generate(world, random, i, j, k)) {
+            if(!((WorldFeature) (treeBig)).place(world, random, i, j, k)) {
                 world.setBlock(i, j, k, id);
             }
         }
